
// SC1000 ExampleDlg.cpp : implementation file
//

#include "stdafx.h"
#include "SC1000 Example.h"
#include "SC1000 ExampleDlg.h"
#include "afxdialogex.h"
#include <array>
#include <vector>

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

using namespace std;

// CSC1000ExampleDlg dialog

CSC1000ExampleDlg::CSC1000ExampleDlg(CWnd* pParent /*=NULL*/)
	: CDialogEx(IDD_SC1000EXAMPLE_DIALOG, pParent)
	, txtAddress(_T(""))
	, numSW1(0)
	, numSW2(0)
	, numSW3(0)
	, numSW4(0)
	, chkOC1(FALSE)
	, chkOC2(FALSE)
	, chkOC3(FALSE)
	, chkOC4(FALSE)
	, chk12V(FALSE)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSC1000ExampleDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_ADDRESS, txtAddress);
	DDX_Control(pDX, IDC_INITIALIZE, btnInitialize);
	DDX_Control(pDX, IDC_ADDRESS, txtAddressControl);
	DDX_Text(pDX, IDC_SW1, numSW1);
	DDV_MinMaxInt(pDX, numSW1, 1, 4);
	DDX_Text(pDX, IDC_SW2, numSW2);
	DDV_MinMaxInt(pDX, numSW2, 1, 4);
	DDX_Text(pDX, IDC_SW3, numSW3);
	DDV_MinMaxInt(pDX, numSW3, 1, 4);
	DDX_Text(pDX, IDC_SW4, numSW4);
	DDV_MinMaxInt(pDX, numSW4, 1, 4);
	DDX_Check(pDX, IDC_OD1, chkOC1);
	DDX_Check(pDX, IDC_OD2, chkOC2);
	DDX_Check(pDX, IDC_OD3, chkOC3);
	DDX_Check(pDX, IDC_OD4, chkOC4);
	DDX_Check(pDX, IDC_12V, chk12V);
}

BEGIN_MESSAGE_MAP(CSC1000ExampleDlg, CDialogEx)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_INITIALIZE, &CSC1000ExampleDlg::OnBnClickedInitialize)
	ON_WM_CLOSE()
	ON_BN_CLICKED(IDC_SET_ALL, &CSC1000ExampleDlg::OnBnClickedSetAll)
END_MESSAGE_MAP()


// CSC1000ExampleDlg message handlers

BOOL CSC1000ExampleDlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	txtAddress = "GPIB0::1::INSTR";
	numSW1 = 1;
	numSW2 = 1;
	numSW3 = 1;
	numSW4 = 1;
	UpdateData(false);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CSC1000ExampleDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialogEx::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CSC1000ExampleDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}



void CSC1000ExampleDlg::OnBnClickedInitialize()
{
	CString address;
	txtAddressControl.GetWindowText(address);
	string strAddress(address);

	CWaitCursor wait;

	// Initialize a new session
	sc.Initialize(strAddress);

	sc.Power(true);

	// Query the current state of the switches
	numSW1 = sc.QuerySwitch(1);
	numSW2 = sc.QuerySwitch(2);
	numSW3 = sc.QuerySwitch(3);
	numSW4 = sc.QuerySwitch(4);

	// Query the current state of the open drain outputs
	chkOC1 = sc.QueryOpenCollector(1);
	chkOC2 = sc.QueryOpenCollector(2);
	chkOC3 = sc.QueryOpenCollector(3);
	chkOC4 = sc.QueryOpenCollector(4);

	// Query the current state of the 12V trigger
	chk12V = sc.Query12V();

	UpdateData(false);
}


void CSC1000ExampleDlg::OnClose()
{
	sc.Close();
	CDialogEx::OnClose();
}


void CSC1000ExampleDlg::OnBnClickedSetAll()
{
	if (UpdateData(true))
	{
		CWaitCursor wait;

		// Set each switch
		sc.SetSwitch(1, numSW1);
		sc.SetSwitch(2, numSW2);
		sc.SetSwitch(3, numSW3);
		sc.SetSwitch(4, numSW4);

		// Set each open collector
		sc.SetOpenCollector(1, chkOC1);
		sc.SetOpenCollector(2, chkOC2);
		sc.SetOpenCollector(3, chkOC3);
		sc.SetOpenCollector(4, chkOC4);

		// Set the 12V trigger
		sc.Set12V(chk12V);
	}
}
