
// SC2000 ExampleDlg.cpp : implementation file
//

#include "stdafx.h"
#include "SC2000 Example.h"
#include "SC2000 ExampleDlg.h"
#include "afxdialogex.h"
#include <array>
#include <vector>

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

using namespace std;

// CSC2000ExampleDlg dialog

CSC2000ExampleDlg::CSC2000ExampleDlg(CWnd* pParent /*=NULL*/)
	: CDialogEx(IDD_SC2000EXAMPLE_DIALOG, pParent)
	, txtAddress(_T(""))
	, numSW1(0)
	, numSW2(0)
	, numSW3(0)
	, numSW4(0)
	, chkOD1(FALSE)
	, chkOD2(FALSE)
	, chkOD3(FALSE)
	, chkOD4(FALSE)
	, chkTTL1(FALSE)
	, chkTTL2(FALSE)
	, chkTTL3(FALSE)
	, chkTTL4(FALSE)
	, cbConfig(_T(""))
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSC2000ExampleDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_ADDRESS, txtAddress);
	DDX_Control(pDX, IDC_INITIALIZE, btnInitialize);
	DDX_Control(pDX, IDC_ADDRESS, txtAddressControl);
	DDX_Control(pDX, IDC_IDN, txtIDN);
	DDX_Text(pDX, IDC_SW1, numSW1);
	DDV_MinMaxInt(pDX, numSW1, 1, 4);
	DDX_Text(pDX, IDC_SW2, numSW2);
	DDV_MinMaxInt(pDX, numSW2, 1, 4);
	DDX_Text(pDX, IDC_SW3, numSW3);
	DDV_MinMaxInt(pDX, numSW3, 1, 4);
	DDX_Text(pDX, IDC_SW4, numSW4);
	DDV_MinMaxInt(pDX, numSW4, 1, 4);
	DDX_Check(pDX, IDC_OD1, chkOD1);
	DDX_Check(pDX, IDC_OD2, chkOD2);
	DDX_Check(pDX, IDC_OD3, chkOD3);
	DDX_Check(pDX, IDC_OD4, chkOD4);
	DDX_Check(pDX, IDC_TTL1, chkTTL1);
	DDX_Check(pDX, IDC_TTL2, chkTTL2);
	DDX_Check(pDX, IDC_TTL3, chkTTL3);
	DDX_Check(pDX, IDC_TTL4, chkTTL4);
	DDX_Control(pDX, IDC_CB_CONFIG, cbConfigControl);
	DDX_CBString(pDX, IDC_CB_CONFIG, cbConfig);
}

BEGIN_MESSAGE_MAP(CSC2000ExampleDlg, CDialogEx)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_INITIALIZE, &CSC2000ExampleDlg::OnBnClickedInitialize)
	ON_WM_CLOSE()
	ON_BN_CLICKED(IDC_SET_ALL, &CSC2000ExampleDlg::OnBnClickedSetAll)
	ON_BN_CLICKED(IDC_SAVE_CONFIG, &CSC2000ExampleDlg::OnBnClickedSaveConfig)
	ON_BN_CLICKED(IDC_LOAD_CONFIG, &CSC2000ExampleDlg::OnBnClickedLoadConfig)
END_MESSAGE_MAP()


// CSC2000ExampleDlg message handlers

BOOL CSC2000ExampleDlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	txtAddress = "GPIB0::1::INSTR";
	numSW1 = 1;
	numSW2 = 1;
	numSW3 = 1;
	numSW4 = 1;
	cbConfig = "USER1";

	UpdateData(false);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CSC2000ExampleDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialogEx::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CSC2000ExampleDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}



void CSC2000ExampleDlg::OnBnClickedInitialize()
{
	CString address;
	txtAddressControl.GetWindowText(address);
	string strAddress(address);

	CWaitCursor wait;

	sc.Close();

	// Initialize a new session
	sc.Initialize(strAddress);

	// Query the ID string
	CString strIDN(sc.QueryID().c_str());
	txtIDN.SetWindowText(strIDN);

	// Query the current state of the switches
	numSW1 = sc.QuerySwitch(1);
	numSW2 = sc.QuerySwitch(2);
	numSW3 = sc.QuerySwitch(3);
	numSW4 = sc.QuerySwitch(4);

	// Query the current state of the open drain outputs
	chkOD1 = sc.QueryOpenDrain(1);
	chkOD2 = sc.QueryOpenDrain(2);
	chkOD3 = sc.QueryOpenDrain(3);
	chkOD4 = sc.QueryOpenDrain(4);

	// Query the current state of the TTL outputs
	chkTTL1 = sc.QueryTTL(1);
	chkTTL2 = sc.QueryTTL(2);
	chkTTL3 = sc.QueryTTL(3);
	chkTTL4 = sc.QueryTTL(4);

	UpdateData(false);
}


void CSC2000ExampleDlg::OnClose()
{
	// Set the SC2000 back to local mode before closing
	sc.LocalMode();
	sc.Close();
	CDialogEx::OnClose();
}


void CSC2000ExampleDlg::OnBnClickedSetAll()
{
	if (UpdateData(true))
	{
		CWaitCursor wait;

		// Create 2D vectors of the form {switch/open drain/TTL, position} in each row
		vector<vector<int>> switches = { {1, numSW1}, {2, numSW2}, {3, numSW3}, {4, numSW4} };
		vector<vector<int>> openDrains = { {1, chkOD1}, {2, chkOD2}, {3, chkOD3}, {4, chkOD4} };
		vector<vector<int>> ttls = { {1, chkTTL1}, {2, chkTTL2}, {3, chkTTL3}, {4, chkTTL4} };

		// Use the functions that set multiple switches and outputs in a single command.
		// These are faster since the safety switch only needs to be set once during each command.
		sc.SetSwitches(switches);
		sc.SetOpenDrains(openDrains);
		sc.SetTTLs(ttls);
	}
}


void CSC2000ExampleDlg::OnBnClickedSaveConfig()
{
	CString config;
	SC2000::ConfigName configName;
	cbConfigControl.GetWindowText(config);

	// Select the configuration name enum value and save the current configuration
	if (config == "USER2")
		sc.SaveConfiguration(SC2000::ConfigName::USER2);
	else if (config == "INT1")
		sc.SaveConfiguration(SC2000::ConfigName::INT1);
	else if (config == "SAFE")
		sc.SaveConfiguration(SC2000::ConfigName::SAFE);
	else
		sc.SaveConfiguration(SC2000::ConfigName::USER1);
}


void CSC2000ExampleDlg::OnBnClickedLoadConfig()
{
	CString config;
	SC2000::ConfigName configName;
	cbConfigControl.GetWindowText(config);

	CWaitCursor wait;

	// Select the configuration name enum value and load the saved configuration
	if (config == "USER2")
		sc.LoadConfiguration(SC2000::ConfigName::USER2);
	else if (config == "INT1")
		sc.LoadConfiguration(SC2000::ConfigName::INT1);
	else if (config == "SAFE")
		sc.LoadConfiguration(SC2000::ConfigName::SAFE);
	else
		sc.LoadConfiguration(SC2000::ConfigName::USER1);
}
